#ifndef __MAIN_H__
#define __MAIN_H__

#include "RkAudio.h"
#include <fstream>
#include <memory>

class SpeexDsp;
class WebRtcAecm;
class Task {
public:
    virtual void run() = 0;
};

class RecorderTask : public Task {
public:
    void run() final;

private:
    std::shared_ptr<RkAudio::Input> m_input;
    std::shared_ptr<std::ofstream> m_ofs;
};

class PlayerTask : public Task {
public:
    void setChannels(int channels);
    void setPath(const std::string &path);
    void run() final;

protected:
    void play();

private:
    int m_channels = 2;
    std::string m_path;
    std::vector<char> m_buffer;
    std::shared_ptr<std::ifstream> m_ifs;
    std::shared_ptr<RkAudio::Output> m_output;
};

class EchoRecordTask : public Task {
public:
    void setVqeEnabled(bool enabled);
    void setChannels(int channels);
    void run() final;

private:
    int m_channels = 2;
    bool m_vqeEnabled = false;
    std::shared_ptr<RkAudio::Output> m_output;
    std::shared_ptr<RkAudio::Input> m_input;
    std::shared_ptr<SpeexDsp> m_speex;
    std::shared_ptr<WebRtcAecm> m_webRtcAecm;
    std::vector<uint8_t> m_outBuffer;

    std::vector<uint8_t> m_nearendBuffer;
    std::vector<uint8_t> m_farendBuffer;
};

#endif // __MAIN_H__